<script src="https://cdnjs.cloudflare.com/ajax/libs/echarts/4.8.0/echarts-en.common.min.js" 
    integrity="sha512-/Q40jZijQiufYjvG6aiUq9PTUrOt/E9igis1ZLbZv89yl2FIsSwgeZr6w7WipE6ALQ5DuWME/BSCl9F0u0eunQ==" 
    crossorigin="anonymous"></script>
<script>
    var chartElement = document.getElementById('chart');
    var toolbox = {
        show: true,
        orient: 'horizontal',
        left: 'center',
        top: 'bottom',
        itemGap: 30,
        feature: {
            mark: {
                show: true
            },
            dataView: {
                show: true
            },
            magicType: {
                show: true,
                type: ['line', 'bar']
            },
            restore: {
                show: true
            },
            saveAsImage: {
                show: true
            }
        }
    };

    function initChart() {
        var chart = echarts.init(chartElement);

        var option = {
            tooltip: {
                trigger: 'axis',
                axisPointer: {
                    type: 'shadow'
                }
            },
            legend: {
                data: <%- JSON.stringify(analytics.rows.map(x => x.class_group)) %>
            },
            toolbox: toolbox,
            calculable: true,
            xAxis: {
                name: 'Step ordinal',
                nameLocation: 'center',
                nameGap: 25,
                type: 'category',
                data: <%- JSON.stringify(chartData[0]) %>
            },
            yAxis: {
                name: 'Students finished step',
                nameGap: 25,
                nameLocation: 'center',
                nameRotate: 90,
                type: 'value'
            },
            toolbox: toolbox,
            series: [
                <% analytics.rows.forEach((row, idx) => { %> {
                    name: "<%- row.class_group %>",
                    data: [
                        <% Object.entries(row).forEach(([key, value], idx, arr) => { %>
                        <% if (!isNaN(key)) { %>
                        <%- value %>
                        <% if (idx != arr.length) { %>, <% } %>
                        <% } %>
                        <% }); %>
                    ],
                    type: 'bar'
                }
                <% if (idx < analytics.rows.length) { %>, <% } %>
                <% }); %>
            ]
        };

        chart.setOption(option);
    }

    initChart();
</script>